<?php

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once( JPATH_BASE . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php');

class plgCommunityJDonation extends CApplications
{

	var $name 		= "JoomDonation Application";
	var $_name		= 'joomdonation';
	var $_path		= '';
	var $_user		= '';
	var $_my		= '';

    function plgCommunityJDonation(& $subject, $config)
    {
    	$this->_path	= JPATH_BASE . DS . 'administrator' . DS . 'components' . DS . 'com_jdonation';
		$this->_user	= CFactory::getActiveProfile();
		$this->_my		= CFactory::getUser();			
		parent::__construct($subject, $config);
    }
		
	function onProfileDisplay()
	{								
		if( !file_exists( $this->_path . DS . 'jdonation.php' ) ){			
			$content = "<div class=\"icon-nopost\"><img src='".JURI::base()."components/com_community/assets/error.gif' alt=\"\" /></div>";	
			$content .= "<div class=\"content-nopost\">".JText::_('JoomDonation is not installed. Please contact site administrator.')."</div>";
		}else{			
			$user		= CFactory::getActiveProfile();			
			$userId = $user->id;
			$currentUserId = $this->_my->id ;
			$numberRecord = $this->params->get('number_records', 10);
			$rows	= $this->_getDonations($userId, $numberRecord);
			$total = $this->_getTotal($userId) ;														
			$content = $this->_getJDonationHTML($rows, $userId, $currentUserId, $total) ;
		}	
		return $content;
	}
	
	function _getJDonationHTML($rows, $userId, $currentUserId, $total){			
		require_once (JPATH_ROOT.DS.'components'.DS.'com_jdonation'.DS.'helper'.DS.'helper.php');
		JoomDonationHelper::loadLanguage();
		$config = JoomDonationHelper::getConfig();
		$db = & JFactory::getDBO();
		$sql = 'SELECT config_value FROM #__jd_configs WHERE config_key="currency_symbol"';
		$db->setQuery($sql);
		$currencySymbol = $db->loadResult();
		ob_start();		
		if (count($rows) == 0) {
			if ($userId == $currentUserId)
				$text = JText::_('JD_YOU_MADE_NO_DONATION');
			else 
				$text = JText::_('JD_MADE_NO_DONATION' );	
		?>
			<table width="100%" cellspacing="3" cellpadding="3">
				<tr>
					<td>
						<p class="message"><?php echo $text ; ?></p>
					</td>
				</tr>
			</table>			
		<?php	
		} else {
		?>
			<table width="100%" cellspacing="3" cellpadding="3" class="jd_donation_history">
				<tr>
					<td class="sectiontableheader">
						<?php echo JText::_('JD_NO'); ?>
					</td>
					<td class="sectiontableheader">
						<?php echo JText::_('JD_DONATION_AMOUNT')." ($currencySymbol)";?>
					</td>
					<td class="sectiontableheader">
						<?php echo JText::_('JD_DONATION_DATE'); ?>
					</td>
					<td class="sectiontableheader">
						<?php echo JText::_('JD_PAYMEMNT_METHOD') ?>
					</td>
					<td class="sectiontableheader">
						<?php echo JText::_('JD_TRANSACTION_ID') ?>
					</td>
				</tr>
				<?php
					$tabs = array('sectiontableentry1', 'sectiontableentry2');
					$k = 0;
					for($i=0, $n = count($rows); $i < $n; $i++) {
						$row = $rows[$i];
						$tab = $tabs[$k];
					?>
					<tr class="<?php echo $tab; ?>">
						<td>
							<?php echo ($i + 1); ?>
						</td>
						<td>
							<?php echo  number_format($row->amount, 2); ?>
						</td>
						<td>
							<?php echo JHTML::_('date', $row->created_date, $config->date_format); ?>
						</td>
						<td>
							<?php									
								echo JText::_(strtoupper($row->payment_method)) ;	
							?>
						</td>
						<td>
							<?php echo $row->transaction_id; ?>
						</td>
					</tr>
					<?php	
						$k =  1 - $k;	
					}
					if (count($rows) < $total) {
					?>
						<tr>
							<td colspan="5" style="text-align: right;">
								<strong><a  href="index.php?option=com_jdonation&view=donors&user_id=<?php echo $userId; ?>" target="_blank"><?php echo JText::_('JD_VIEW_ALL'); ?></a></strong>
							</td>
						</tr>							
					<?php	
					}
				?>															
			</table>
		<?php	
		}
		$output = ob_get_contents();
		ob_end_clean();			
		return $output ;					
	}
	
	/**
	 * Returns the list of videos and its properties for the specific browsed user
	 * 
	 * @access private
	 * 
	 * returns	Array	An array of object list
	 **/	 	
	function _getDonations($userId, $numberRecords)
	{
		$db		= & JFactory::getDBO();
		$sql = 'SELECT * FROM #__jd_donors WHERE user_id='.$userId.' AND hide_me =0 AND published=1 ORDER BY id LIMIT '.$numberRecords;
		$db->setQuery($sql);		
		return $db->loadObjectList();									
	}
	/**
	 * Get total number of donation records
	 *
	 */
	function _getTotal($userId) {
		$db		= & JFactory::getDBO();
		$sql = 'SELECT COUNT(*) FROM #__jd_donors WHERE user_id='.$userId.' AND hide_me = 0 AND published = 1 ';
		$db->setQuery($sql);		
		return $db->loadResult();
	}		
}
